#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>
#include <math.h>

#include "mpx.h"

void do_wave(int fd, int perio, int channels, int delay);

int main(int argc, char* argv[]){
	int serial_fd;
	int delay = 0;
	if(argc < 3){
		fprintf(stderr, "usage: wave period channels [delay]\n");
		return 1;
	}
	serial_fd = serial_init();
	if(argc > 3)
		delay = strtol(argv[3], NULL, 0);

	do_wave(serial_fd, strtol(argv[1], NULL, 0), strtol(argv[2], NULL, 0), delay);
	return 0;
}

void do_wave(int fd, int period, int channels, int delay){
	unsigned char buf[3];
	float value;
	int x=0;
	int y=0;
	buf[0]=DAT_MAGIC;
	while(1){
		for(y=0; y<channels; y++){
			value = (sin((x + y)/(float)period) + 1)/2 * MAX_VALUE;
			buf[2] = value;
			write(fd, &buf[2], 1);
			if(delay > 0)
				usleep(delay);
		}
		buf[1] = 0;
		write(fd, buf, 2);
		x++;
	}
}
